#define private public
#include <PSX/File/Processor/File_Processor.hpp>
#include <stdio.h>

namespace FileProcessor {
    union SimpleTIMState {
        State::Reserved _reserved;
        struct {
            uint32_t test;
        };

        constexpr SimpleTIMState(uint32_t test = 0) : test(test) {
        }
    };
    static_assert(sizeof(SimpleTIMState) <= sizeof(State::Reserved));

    static bool process(uint32_t*, size_t, SimpleTIMState &state) {
        printf("Dino: %i\n", state.test);
        return false;
    }

    State create(const SimpleTIM& file) {
        SimpleTIMState test(123);
        
        return State{.process_adr = reinterpret_cast<State::ProcessRoutine>(process), .reserved = test._reserved};
    }
}

#undef private